]> git.donarmstrong.com Git - deb_pkgs/autorandr.git/blob - autorandr
Merge https://github.com/ChrisDunder/autorandr
[deb_pkgs/autorandr.git] / autorandr
1 #!/bin/sh
2 #
3 # Automatically select a display configuration based on connected devices
4 #
5 # Stefan Tomanek <stefan.tomanek@wertarbyte.de>
6 #
7 # How to use:
8 #
9 # Save your current display configuration and setup with:
10 #  $ autorandr --save mobile
11 #
12 # Connect an additional display, configure your setup and save it:
13 #  $ autorandr --save docked
14 #
15 # Now autorandr can detect which hardware setup is active:
16 #  $ autorandr
17 #    mobile
18 #    docked (detected)
19 #
20 # To automatically reload your setup, just append --change to the command line
21 #
22 # To manually load a profile, you can use the --load <profile> option.
23 #
24 # autorandr tries to avoid reloading an identical configuration. To force the
25 # (re)configuration, apply --force.
26 #
27 # To prevent a profile from being loaded, place a script call "block" in its
28 # directory. The script is evaluated before the screen setup is inspected, and
29 # in case of it returning a value of 0 the profile is skipped. This can be used
30 # to query the status of a docking station you are about to leave.
31 #
32 # If no suitable profile can be identified, the current configuration is kept.
33 # To change this behaviour and switch to a fallback configuration, specify
34 # --default <profile>
35 #
36 # Another script called "postswitch "can be placed in the directory
37 # ~/.autorandr as well as in all profile directories: The scripts are executed
38 # after a mode switch has taken place and can notify window managers or other
39 # applications about it.
40 #
41 #
42 # While the script uses xrandr by default, calling it by the name "autodisper"
43 # or "auto-disper" forces it to use the "disper" utility, which is useful for
44 # controlling nvidia chipsets. The formats for fingerprinting the current setup
45 # and saving/loading the current configuration are adjusted accordingly.
46
47 XRANDR=/usr/bin/xrandr
48 DISPER=/usr/bin/disper
49 XDPYINFO=/usr/bin/xdpyinfo
50 PROFILES=~/.autorandr/
51 CONFIG=~/.autorandr.conf
52
53 CHANGE_PROFILE=0
54 FORCE_LOAD=0
55 DEFAULT_PROFILE=""
56 SAVE_PROFILE=""
57
58 FP_METHODS="setup_fp_sysfs_edid setup_fp_xrandr_edid"
59 CURRENT_CFG_METHOD="current_cfg_xrandr"
60 LOAD_METHOD="load_cfg_xrandr"
61
62 SCRIPTNAME="$(basename $0)"
63 # when called as autodisper/auto-disper, we assume different defaults
64 if [ "$SCRIPTNAME" = "auto-disper" ] || [ "$SCRIPTNAME" = "autodisper" ]; then
65         echo "Assuming disper defaults..." >&2
66         FP_METHODS="setup_fp_disper"
67         CURRENT_CFG_METHOD="current_cfg_disper"
68         LOAD_METHOD="load_cfg_disper"
69 fi
70
71 if [ -f $CONFIG ]; then
72         echo "Loading configuration from '$CONFIG'" >&2
73         . $CONFIG
74 fi
75
76 setup_fp_xrandr_edid() {
77         $XRANDR -q --verbose | awk '
78         /^[^ ]+ (dis)?connected / { DEV=$1; }
79         $1 ~ /^[a-f0-9]+$/ { ID[DEV] = ID[DEV] $1 }
80         END { for (X in ID) { print X " " ID[X]; } }'
81 }
82
83 setup_fp_sysfs_edid() {
84         # xrandr triggers the reloading of EDID data
85         $XRANDR -q > /dev/null
86         # hash the EDIDs of all _connected_ devices
87         for P in /sys/class/drm/card*-*/; do
88                 # nothing found
89                 [ ! -d "$P" ] && continue
90                 if grep -q "^connected$" < "${P}status"; then
91                         echo -n "$(basename "$P") "
92                         md5sum ${P}edid | awk '{print $1}'
93                 fi
94         done
95 }
96
97 setup_fp_disper() {
98         $DISPER -l | grep '^display '
99 }
100
101 setup_fp() {
102         local FP="";
103         for M in $FP_METHODS; do
104                 FP="$($M)"
105                 if [ -n "$FP" ]; then
106                         break
107                 fi
108         done
109         if [ -z "$FP" ]; then
110                 echo "Unable to fingerprint display configuration" >&2
111                 return
112         fi
113         echo "$FP"
114 }
115
116 current_cfg_xrandr() {
117         local PRIMARY_SETUP="";
118         if [ -x "$XDPYINFO" ]; then
119                 PRIMARY_SETUP="$($XDPYINFO -ext XINERAMA | awk '/^  head #0:/ {printf $3 $5}')"
120         fi
121         $XRANDR -q | awk -v primary_setup="${PRIMARY_SETUP}" '
122         # display is connected and has a mode
123         /^[^ ]+ connected [^(]/ {
124                 print "output "$1;
125                 if ($3 == "primary") {
126                         print $3
127                         split($4, A, "+")
128                         $4=$5
129                 }
130                 else {
131                         split($3, A, "+");
132                         if (A[1] A[2] "," A[3] == primary_setup)
133                                 print "primary";
134                 }
135                 if (($4 == "left") || ($4 == "right")) {
136                         split(A[1], B, "x");
137                         A[1] = B[2]"x"B[1];
138                         print "rotate "$4;
139                 }
140                 print "mode "A[1];
141                 print "pos "A[2]"x"A[3];
142                 if ($4 !~ /^\(/) {
143                         print "rotate "$4;
144                 }
145                 next;
146         }
147         # disconnected or disabled displays
148         /^[^ ]+ (dis)?connected / ||
149         /^[^ ]+ unknown connection / {
150                 print "output "$1;
151                 print "off";
152                 next;
153         }'
154 }
155
156 current_cfg_disper() {
157         $DISPER -p
158 }
159
160 current_cfg() {
161         $CURRENT_CFG_METHOD;
162 }
163
164 blocked() {
165         local PROFILE="$1"
166         [ ! -x "$PROFILES/$PROFILE/block" ] && return 1
167
168         "$PROFILES/$PROFILE/block" "$PROFILE"
169 }
170
171 config_equal() {
172         local PROFILE="$1"
173         if [ "$(cat "$PROFILES/$PROFILE/config")" = "$(current_cfg)" ]; then
174                 echo "Config already loaded"
175                 return 0
176         else
177                 return 1
178         fi
179 }
180
181 load_cfg_xrandr() {
182         # sed 1: Prefix arguments with "--"
183         # sed 2: Merge arguments into one line per output
184         # sed 3: Merge into two lines, all --off outputs in the first one
185         sed 's/^/--/' "$1" | sed -e '
186                 :START
187                 /\n--output/{P;D}
188                 s/\n/ /
189                 N;bSTART' | sed -e '
190                         ### First line
191                         / --off/{
192                                 G
193                                 # Merge if next line contains --off
194                                 s/\n\([^\n]* --off\)/ \1/
195                                 h
196                                 $!d;b
197                         }
198                         ### Last line
199                         H;x
200                         # Merge if previous line contains --mode
201                         s/\(--mode [^\n]*\)\n/\1 /
202                         h
203                         $!d' | xargs -L 1 $XRANDR
204 }
205
206 load_cfg_disper() {
207         $DISPER -i < "$1"
208 }
209
210 load() {
211         local PROFILE="$1"
212         local CONF="$PROFILES/$PROFILE/config"
213         if [ -e "$CONF" ] ; then
214     [ -x "$PROFILES/preswitch" ] && \
215       "$PROFILES/preswitch" "$PROFILE"
216     [ -x "$PROFILES/$PROFILE/preswitch" ] && \
217       "$PROFILES/$PROFILE/preswitch" "$PROFILE"
218
219                 echo " -> loading profile $PROFILE"
220                 $LOAD_METHOD "$CONF"
221
222                 [ -x "$PROFILES/$PROFILE/postswitch" ] && \
223                         "$PROFILES/$PROFILE/postswitch" "$PROFILE"
224                 [ -x "$PROFILES/postswitch" ] && \
225                         "$PROFILES/postswitch" "$PROFILE"
226         fi
227 }
228
229 help() {
230         cat <<EOH
231 Usage: $SCRIPTNAME [options]
232
233 -h, --help              get this small help
234 -c, --change            reload current setup
235 -s, --save <profile>    save your current setup to profile <profile>
236 -l, --load <profile>    load profile <profile>
237 -d, --default <profile> make profile <profile> the default profile
238 --force                 force (re)loading of a profile
239 --fingerprint           fingerprint your current hardware setup
240 --config                dump your current xrandr setup
241
242  To prevent a profile from being loaded, place a script call "block" in its
243  directory. The script is evaluated before the screen setup is inspected, and
244  in case of it returning a value of 0 the profile is skipped. This can be used
245  to query the status of a docking station you are about to leave.
246
247  If no suitable profile can be identified, the current configuration is kept.
248  To change this behaviour and switch to a fallback configuration, specify
249  --default <profile>.
250
251  Another script called "postswitch "can be placed in the directory
252  ~/.autorandr as well as in any profile directories: The scripts are executed
253  after a mode switch has taken place and can notify window managers.
254
255  When called by the name "autodisper" or "auto-disper", the script uses "disper"
256  instead of "xrandr" to detect, configure and save the display configuration.
257
258 EOH
259         exit
260 }
261 # process parameters
262 OPTS=$(getopt -n autorandr -o s:l:d:cfh --long change,default:,save:,load:,force,fingerprint,config,help -- "$@")
263 if [ $? != 0 ] ; then echo "Terminating..." >&2 ; exit 1 ; fi
264 eval set -- "$OPTS"
265
266 while true; do
267         case "$1" in
268                 -c|--change) CHANGE_PROFILE=1; shift ;;
269                 -d|--default) DEFAULT_PROFILE="$2"; shift 2 ;;
270                 -s|--save) SAVE_PROFILE="$2"; shift 2 ;;
271                 -l|--load) LOAD_PROFILE="$2"; shift 2 ;;
272                 -h|--help) help ;;
273                 --force) FORCE_LOAD=1; shift ;;
274                 --fingerprint) setup_fp; exit 0;;
275                 --config) current_cfg; exit 0;;
276                 --) shift; break ;;
277                 *) echo "Error: $1"; exit 1;;
278         esac
279 done
280
281 CURRENT_SETUP="$(setup_fp)"
282
283 if [ -n "$SAVE_PROFILE" ]; then
284         echo "Saving current configuration as profile '${SAVE_PROFILE}'"
285         mkdir -p "$PROFILES/$SAVE_PROFILE"
286         echo "$CURRENT_SETUP" > "$PROFILES/$SAVE_PROFILE/setup"
287         $CURRENT_CFG_METHOD > "$PROFILES/$SAVE_PROFILE/config"
288         exit 0
289 fi
290
291 if [ -n "$LOAD_PROFILE" ]; then
292         CHANGE_PROFILE=1 FORCE_LOAD=1 load "$LOAD_PROFILE"
293         exit $?
294 fi
295
296 for SETUP_FILE in $PROFILES/*/setup; do
297         if ! [ -e $SETUP_FILE ]; then
298                 break
299         fi
300         PROFILE="$(basename $(dirname "$SETUP_FILE"))"
301         echo -n "$PROFILE"
302
303         if blocked "$PROFILE"; then
304                 echo " (blocked)"
305                 continue
306         fi
307
308         FILE_SETUP="$(cat "$PROFILES/$PROFILE/setup")"
309         if [ "$CURRENT_SETUP" = "$FILE_SETUP" ]; then
310                 echo " (detected)"
311                 if [ "$CHANGE_PROFILE" -eq 1 ]; then
312                         if [ "$FORCE_LOAD" -eq 1 ] || ! config_equal "$PROFILE"; then
313                                 load "$PROFILE"
314                         fi
315                 fi
316                 # found the profile, exit with success
317                 exit 0
318         else
319                 echo ""
320         fi
321 done
322
323 # we did not find the profile, load default
324 if [ -n "$DEFAULT_PROFILE" ]; then
325         echo "No suitable profile detected, falling back to $DEFAULT_PROFILE"
326         load "$DEFAULT_PROFILE"
327 fi
328 exit 1